
from scipy import *
from pylab import *
import pylab

invsigsq  = 0.01

background = 0.2
color_img = imread("truchet.png")
img_swatch  = 0.5*(1-color_img[:,:,0]) + background
n_s = len(img_swatch)
n = 2*n_s
img = background*ones((n,n))
img[0:n_s,0:n_s] = img_swatch


filtery = matrix(array([(exp(-(k**2)*invsigsq) + exp(-((n-k)**2)*invsigsq)) for k in range(n)],dtype=float))
filterx = transpose(filtery)
filter = array(filterx*filtery)
m = (filter > 1e-05) 
#misc.imsave("point_image.png",real(ifft2(filter)))
#toimage(filter, cmin=0, cmax=255).save("point_image.png")
save("point_image1.txt",real(ifft2(filter)))

delta = zeros((n,n))
delta[n/4,n/4] = 1.0
deltak = fft2(delta);
blurredk  = filter*fft2(img)*deltak
blurred  = real(ifft2(blurredk))


ampl = 0.0005
noise = ampl*standard_normal((n,n))
y = blurred + noise  
mask = (y>1.0) + (y < 0.0) + 0

signal = blurred*mask + y * (1- mask)

#imshow(signal)
save("sample_image1.txt",signal)
misc.imsave("sample_image1.png",signal)
#toimage(filter, cmin=0, cmax=255).save("sample_image.png")

Sk = fft2(signal)
#N = 0.0*(n*ampl)**2
N = 113
N = 6.0

reconstrk = zeros((n,n),dtype=complex)

for kx in range(n): 
   for ky in range(n): 
      if m[kx,ky]: 
         reconstrk[kx,ky] = (Sk[kx,ky]/filter[kx,ky]) * abs(Sk[kx,ky])**2/(abs(Sk[kx,ky])**2 + N)


colormap = pylab.cm.gist_gray
imshow(real(ifft2(reconstrk)),cmap=colormap)
   
show()
