
from scipy import *
from pylab import *

def projection(angle,img,bin_size):
   m = len(img)
   n = size(img)/len(img)
   print n,m
   center = (m/2,n/2)
   x_min = min(n,m)
   array_size = int(x_min/bin_size)
   proj= zeros(int(x_min/bin_size))
   lower = -x_min/2
   upper = x_min/2
   dir = (cos(angle),sin(angle))

   for x in range(lower,upper):
      for y in range(lower,upper):
	 v = (x,y)
	 dot = v[0]*dir[0]+v[1]*dir[1]
	 if abs(dot) >= x_min/2: continue
	 bin = int((dot+upper)/bin_size) 
	 coord = v+center
	 ix = int(x+m/2)
	 iy = int(y+n/2)
	 if bin < 0: print bin
	 if bin >= x_min: print bin
	 if ix < 0: print ix
	 if iy < 0: print iy
	 proj[bin] += img[ix,iy]

   return proj



   


img = imread("mystery_image.png")
shp = shape(img)
n_size = 1024
padded = zeros((n_size,n_size))
s_size = 8
background = mean(img[0:s_size,0:s_size])
padded[0:-1,0:-1] = background
x_low = n_size/2-shp[0]/2
x_high = n_size/2+shp[0]/2 +1
y_low = n_size/2-shp[1]/2
y_high = n_size/2+shp[1]/2
padded[x_low:x_high, y_low:y_high] = img[0:shp[0],0:shp[1]]

n_angle = n_size/4

out = zeros((n_angle,n_angle))
for i in range(n_angle): 
   p = projection(i*pi/n_angle,padded,4.0)
   out[i,:] = p

savetxt("tom.txt",out)

