
from scipy import *
from pylab import *
import time
import sys
import numpy as npy

def randdir():
    n = randint(6)
    return dir[n]

def randsphere(radius = 10.0):
    while 1:
        r = npy.random.random(3) - array((0.5,0.5,0.5))
        rsq = sum(r*r)
        if rsq < 1:
            return radius*r/sqrt(rsq)


def int_randsphere(radius): 
    return ceil(randsphere(radius))

Seed = 10000
seed(Seed)
    
dir = array( [ [1,0,0], [-1,0,0], [0,1,0], [0,-1,0], [0,0,1], [0,0,-1]])

r = zeros((3))
graphics = 1
if graphics:
    from visual import *
    ion()


outer_radius = 40
starting_radius = 20
outer_radius_sq = outer_radius**2

absorb_radius = 10 
absradsq = absorb_radius**2
num_absorbed = 0
num_escaped = 0


y_offset = -3
r_offset = array((0,y_offset,0))
ball_radius = 0.3

if graphics:
   ball = sphere (pos=(0,10+y_offset,0), radius=ball_radius, color=color.green)
   abs_sphere = sphere (pos=(0,y_offset,0), radius=absorb_radius, color=color.red)
   rod = cylinder(pos=(0,y_offset,0), axis=(0,outer_radius,0), radius=ball_radius, color=color.red)

for i in range(10000):
    r = int_randsphere(starting_radius)

    if graphics:
        ball.radius = 0.3
        ball.color = color.red
    while 1:

        if graphics:
            rate(10)
            ball.pos= r + r_offset


        if sum(r*r) < absradsq:
            num_absorbed += 1
            if graphics:
                ball.radius = absorb_radius
                ball.color = color.white
            if num_absorbed % 100 == 0:
                print "num absorbed = ", num_absorbed
            break
 
            key = scene.kb.getkey()
            if (key == 'q'): 
                break

        if sum(r*r) > outer_radius_sq:
            num_escaped += 1
            if num_escaped % 100 == 0:
                print "num escaped = ", num_escaped, " num_absorbed/(num_absorbed+num_escaped) = ", num_absorbed/(1.0*num_absorbed+num_escaped) 
            break


        r += randdir()

    

print "num_absorbed/(num_absorbed+num_escaped) = ", num_absorbed/(1.0*num_absorbed+num_escaped) 
