from scipy import *
from pylab import *
import time


def randdir():
    n = randint(4)
    return dir[n]


def randcircle(radius = 10.0):
    while 1:
        r = 2*(random(2) - array((0.5,0.5)))
        rsq = sum(r*r)
        if rsq < 1:
            return radius*r/sqrt(rsq)

def int_randcircle(radius): 
    return int_(randcircle(radius))

dir = array([ [1,0], [-1,0], [0,1], [0,-1]])

Seed = 1000
seed(Seed)


n=20
dim = (n,n)
p = zeros(dim)
diff_field = zeros(dim)
center = (n/2,n/2)
p[center] = 1

r_max = 6

ion()

xcluster=[center[0]]
ycluster=[center[1]]
r_old = zeros((2))

def plot_circle(r,cntr):
    theta = arange(0,2*pi,0.01)
    x = cntr[0]+r*cos(theta)
    y = cntr[1]+r*sin(theta)
    plot(x,y)
    show()
    draw()

First = True
for i in range(1,1000000):
    next_to = False
    if i%1 == 0:
#        imshow(diff_field+p,interpolation="nearest")
#        draw()
	print i
#	show()
	time.sleep(0.1)

    r = int_randcircle(r_max-1)
    plot_circle(r_max,center)
    hold(True)
    plot(array(xcluster),array(ycluster),'r+')
    xlim([0,n])
    ylim([0,n])
    fig = matplotlib.pyplot.gcf()
    fig.set_size_inches(6,6)
    show()
    draw()
    if First == True:
       time.sleep(10.0)
       First = False
    time.sleep(1.0)
    while True:
#	time.sleep(0.1)
        hold(False)
        plot(array([center[0]+r[0]]),array([center[1]+r[1]]),'go',array(xcluster),array(ycluster),'r+')
        xlim([0,n])
        ylim([0,n])
        show()
        draw()
        r_old[:] = r[:]
        r += randdir()
        rsq = r[0]**2+r[1]**2
        if  rsq > r_max**2:
             r[:] = r_old[:]
             print "rsq = ", rsq
        for j in range(4):
            neighbor = center + r + dir[j]
            if p[tuple(neighbor)] > 0:
                next_to = True
                break
        if next_to:
            next_to = False
            p[tuple(center + r)] = sqrt(i)
            xcluster.append(center[0]+r[0])
            ycluster.append(center[1]+r[1])
            break


print "done"
pause(100)
show()
