
from scipy import *
from pylab import *
import pylab

def fold(x):
    if x < n2:
         return x
    else:
         return n-x

def fudge(N):
    return 1-N/SmoothCKsq

signal1 = imread("sample_image.png")
Ck = fft2(signal1)
norm = 1.0/Ck[1,1]
Ck = Ck*norm


n = len(signal1)

sigsq = 1
invsigsq = (32/640.)**2

#Gauss_filtery = matrix(array([(exp(-(k**2)*invsigsq) + exp(-((n-k)**2)*invsigsq)) for k in range(n)],dtype=float))
#Gauss_filterx = transpose(Gauss_filtery)
#Gauss_filter = array(Gauss_filterx*Gauss_filtery)
HighPassFilter = zeros((n,n))
cutoff = 4.
cutoffsq = cutoff**2
n2 = n/2
for kx in range(n): 
   for ky in range(n): 
       ksq = fold(kx)**2+fold(ky)**2
       HighPassFilter[kx,ky] = (ksq/(cutoffsq + ksq))**8
 #      if ksq != 0:
 #           HighPassFilter[kx,ky] = exp(-cutoffsq/ksq)
LowPassFilter = 1-HighPassFilter



filter = imread("point_image.png")
filterk_unorm = real(fft2(filter))
norm= 1./filterk_unorm[0,0]
filterk = norm*filterk_unorm


#m = (filterk > 1e-07) 
m = (filterk > 0)
#N = .000106
N = .000106
Nsq = N*N
#CkConvCk = fft2(abs(Ck)**2)*Gauss_filter
#SmoothCKsq = real(ifft2(CkConvCk))


reconstrk = zeros((n,n),dtype=complex)

for kx in range(n): 
   for ky in range(n): 
      if m[kx,ky]: 
         #reconstrk[kx,ky] = (Ck[kx,ky]/filterk[kx,ky]) * (abs(Ck[kx,ky])**2-N)/(abs(Ck[kx,ky])**2)
         #reconstrk[kx,ky] = (Ck[kx,ky]/filterk[kx,ky]) * (SmoothCKsq[kx,ky]-Nsq)/SmoothCKsq[kx,ky]
         reconstrk[kx,ky] = Ck[kx,ky]*HighPassFilter[kx,ky]
         #reconstrk[kx,ky] = Ck[kx,ky]*LowPassFilter[kx,ky]


colormap = pylab.cm.gist_gray
imshow(real(ifft2(reconstrk)),cmap=colormap)
   
show()
